package com.sa.ibiz.demo.demo.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import lombok.Data;
import org.springframework.beans.BeanUtils;
import org.springframework.cglib.beans.BeanMap;
import org.springframework.cglib.beans.BeanGenerator;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.FieldFill;
import java.util.Map;
import java.util.HashMap;
import org.springframework.util.StringUtils;
import com.sa.ibiz.demo.ibizutil.security.AuthenticationUser;
import java.util.Date;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import org.springframework.cglib.beans.BeanCopier;
import com.sa.ibiz.demo.ibizutil.annotation.Dict;
import com.sa.ibiz.demo.ibizutil.domain.EntityBase;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.enums.FillMode;
import com.sa.ibiz.demo.ibizutil.enums.PredefinedType;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import com.alibaba.fastjson.annotation.JSONField;


/**
 * 实体[YCSQ] 数据对象
 */
@TableName(value = "T_YCSQ",resultMap = "YCSQResultMap")
@JsonIgnoreProperties(ignoreUnknown = true)
@Data
public class YCSQ extends EntityBase implements Serializable{

    private String clsj;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createdate;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String createman;
    private String mdd;
    @Dict(dictName = "ionicdemo_YesNoCodeList")
    private Integer sfxysj;
    private Timestamp sqsj;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updatedate;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String updateman;
    private Timestamp ycrq;
    private Integer ycrs;
    private String ycsm;
    @TableId(value= "ycsqid",type=IdType.UUID)//指定主键生成策略
    private String ycsqid;
    private String ycsqname;
    private String zpclph;
    /**
     *  设置属性值[指派车辆司机]
     *  @param clsj
     */
    public void setClsj(String clsj){
        if(StringUtils.isEmpty(clsj))
            clsj=null;
        this.clsj = clsj;
        this.set("clsjdirtyflag",true);
    }
    /**
     *  获取属性值[指派车辆司机]
     */
    public String getClsj(){
        return this.clsj;
    }
    /**
     *  重置属性值[指派车辆司机]
     */
    public void resetClsj(){
        this.set("clsjdirtyflag",false);
        this.clsj = null;
    }
    /**
     *  设置属性值[建立时间]
     *  @param createdate
     */
    public void setCreatedate(Timestamp createdate){
        this.createdate = createdate;
        this.set("createdatedirtyflag",true);
    }
    /**
     *  获取属性值[建立时间]
     */
    public Timestamp getCreatedate(){
        return this.createdate;
    }
    /**
     *  重置属性值[建立时间]
     */
    public void resetCreatedate(){
        this.set("createdatedirtyflag",false);
        this.createdate = null;
    }
    /**
     *  设置属性值[建立人]
     *  @param createman
     */
    public void setCreateman(String createman){
        if(StringUtils.isEmpty(createman))
            createman=null;
        this.createman = createman;
        this.set("createmandirtyflag",true);
    }
    /**
     *  获取属性值[建立人]
     */
    public String getCreateman(){
        return this.createman;
    }
    /**
     *  重置属性值[建立人]
     */
    public void resetCreateman(){
        this.set("createmandirtyflag",false);
        this.createman = null;
    }
    /**
     *  设置属性值[目的地]
     *  @param mdd
     */
    public void setMdd(String mdd){
        if(StringUtils.isEmpty(mdd))
            mdd=null;
        this.mdd = mdd;
        this.set("mdddirtyflag",true);
    }
    /**
     *  获取属性值[目的地]
     */
    public String getMdd(){
        return this.mdd;
    }
    /**
     *  重置属性值[目的地]
     */
    public void resetMdd(){
        this.set("mdddirtyflag",false);
        this.mdd = null;
    }
    /**
     *  设置属性值[是否需要司机]
     *  @param sfxysj
     */
    public void setSfxysj(Integer sfxysj){
        this.sfxysj = sfxysj;
        this.set("sfxysjdirtyflag",true);
    }
    /**
     *  获取属性值[是否需要司机]
     */
    public Integer getSfxysj(){
        return this.sfxysj;
    }
    /**
     *  重置属性值[是否需要司机]
     */
    public void resetSfxysj(){
        this.set("sfxysjdirtyflag",false);
        this.sfxysj = null;
    }
    /**
     *  设置属性值[申请时间]
     *  @param sqsj
     */
    public void setSqsj(Timestamp sqsj){
        this.sqsj = sqsj;
        this.set("sqsjdirtyflag",true);
    }
    /**
     *  获取属性值[申请时间]
     */
    public Timestamp getSqsj(){
        return this.sqsj;
    }
    /**
     *  重置属性值[申请时间]
     */
    public void resetSqsj(){
        this.set("sqsjdirtyflag",false);
        this.sqsj = null;
    }
    /**
     *  设置属性值[更新时间]
     *  @param updatedate
     */
    public void setUpdatedate(Timestamp updatedate){
        this.updatedate = updatedate;
        this.set("updatedatedirtyflag",true);
    }
    /**
     *  获取属性值[更新时间]
     */
    public Timestamp getUpdatedate(){
        return this.updatedate;
    }
    /**
     *  重置属性值[更新时间]
     */
    public void resetUpdatedate(){
        this.set("updatedatedirtyflag",false);
        this.updatedate = null;
    }
    /**
     *  设置属性值[更新人]
     *  @param updateman
     */
    public void setUpdateman(String updateman){
        if(StringUtils.isEmpty(updateman))
            updateman=null;
        this.updateman = updateman;
        this.set("updatemandirtyflag",true);
    }
    /**
     *  获取属性值[更新人]
     */
    public String getUpdateman(){
        return this.updateman;
    }
    /**
     *  重置属性值[更新人]
     */
    public void resetUpdateman(){
        this.set("updatemandirtyflag",false);
        this.updateman = null;
    }
    /**
     *  设置属性值[用车日期]
     *  @param ycrq
     */
    public void setYcrq(Timestamp ycrq){
        this.ycrq = ycrq;
        this.set("ycrqdirtyflag",true);
    }
    /**
     *  获取属性值[用车日期]
     */
    public Timestamp getYcrq(){
        return this.ycrq;
    }
    /**
     *  重置属性值[用车日期]
     */
    public void resetYcrq(){
        this.set("ycrqdirtyflag",false);
        this.ycrq = null;
    }
    /**
     *  设置属性值[用车人数]
     *  @param ycrs
     */
    public void setYcrs(Integer ycrs){
        this.ycrs = ycrs;
        this.set("ycrsdirtyflag",true);
    }
    /**
     *  获取属性值[用车人数]
     */
    public Integer getYcrs(){
        return this.ycrs;
    }
    /**
     *  重置属性值[用车人数]
     */
    public void resetYcrs(){
        this.set("ycrsdirtyflag",false);
        this.ycrs = null;
    }
    /**
     *  设置属性值[用车说明]
     *  @param ycsm
     */
    public void setYcsm(String ycsm){
        if(StringUtils.isEmpty(ycsm))
            ycsm=null;
        this.ycsm = ycsm;
        this.set("ycsmdirtyflag",true);
    }
    /**
     *  获取属性值[用车说明]
     */
    public String getYcsm(){
        return this.ycsm;
    }
    /**
     *  重置属性值[用车说明]
     */
    public void resetYcsm(){
        this.set("ycsmdirtyflag",false);
        this.ycsm = null;
    }
    /**
     *  设置属性值[用车申请标识]
     *  @param ycsqid
     */
    public void setYcsqid(String ycsqid){
        if(StringUtils.isEmpty(ycsqid))
            ycsqid=null;
        this.ycsqid = ycsqid;
        this.set("ycsqiddirtyflag",true);
    }
    /**
     *  获取属性值[用车申请标识]
     */
    public String getYcsqid(){
        return this.ycsqid;
    }
    /**
     *  重置属性值[用车申请标识]
     */
    public void resetYcsqid(){
        this.set("ycsqiddirtyflag",false);
        this.ycsqid = null;
    }
    /**
     *  设置属性值[用车申请名称]
     *  @param ycsqname
     */
    public void setYcsqname(String ycsqname){
        if(StringUtils.isEmpty(ycsqname))
            ycsqname=null;
        this.ycsqname = ycsqname;
        this.set("ycsqnamedirtyflag",true);
    }
    /**
     *  获取属性值[用车申请名称]
     */
    public String getYcsqname(){
        return this.ycsqname;
    }
    /**
     *  重置属性值[用车申请名称]
     */
    public void resetYcsqname(){
        this.set("ycsqnamedirtyflag",false);
        this.ycsqname = null;
    }
    /**
     *  设置属性值[指派车辆牌照]
     *  @param zpclph
     */
    public void setZpclph(String zpclph){
        if(StringUtils.isEmpty(zpclph))
            zpclph=null;
        this.zpclph = zpclph;
        this.set("zpclphdirtyflag",true);
    }
    /**
     *  获取属性值[指派车辆牌照]
     */
    public String getZpclph(){
        return this.zpclph;
    }
    /**
     *  重置属性值[指派车辆牌照]
     */
    public void resetZpclph(){
        this.set("zpclphdirtyflag",false);
        this.zpclph = null;
    }
    /**
     * 重置当前数据对象属性值
     */
    public  void reset(){
        resetClsj();
        resetCreatedate();
        resetCreateman();
        resetMdd();
        resetSfxysj();
        resetSqsj();
        resetUpdatedate();
        resetUpdateman();
        resetYcrq();
        resetYcrs();
        resetYcsm();
        resetYcsqid();
        resetYcsqname();
        resetZpclph();
    }
     /**
     * 获取数据主键（普通主键与联合主键）
     * @return
     */
    @JsonIgnore
    public Serializable getDefaultPrimaryKey()
    {
	    //随机生成主键
         return  IdWorker.get32UUID();

    }
     /**
     * 复制当前对象数据到目标对象(粘贴重置)
     *
     * @throws Exception
     */
    public YCSQ copyTo(YCSQ targetEntity)
	{
		BeanCopier copier=BeanCopier.create(YCSQ.class, YCSQ.class, false);
		copier.copy(this, targetEntity, null);
        targetEntity.resetYcsqid();
		return targetEntity;
	}
}